#include <AFMotor.h>
#include <IBusBM.h>
AF_DCMotor motor1(1);
AF_DCMotor motor2(2);
AF_DCMotor motor4(4);
double CH5;

void setup() {
Serial.begin(115200);
motor1.setSpeed(200);
motor2.setSpeed(200);
motor4.setSpeed(200);

}

void loop() {
double ch1Value=readChannel(0,-100,100,0);
double ch2Value=readChannel(1,-100,100,0);
double ch5Value=readSwitch(CH5,false);
if (ch5Value==0)  {
motor4.run(RELEASE);
motor4.setSpeed(0);  
}
else {
motor4.run(FORWARD);
motor4.setSpeed(200);  
}
if ((ch1Value==0)&&(ch2Value==0))  {
motor1.run(RELEASE);
motor2.run(RELEASE);
motor1.setSpeed(0);
}
if((ch1Value<30)&&(ch2Value<-50))  {
motor1.run(FORWARD);
motor2.run(FORWARD);  
}
else if((ch1Value<30)&&(ch2Value>50))  {
motor1.run(BACKWARD);
motor2.run(BACKWARD);  
}

else if((ch1Value<-50)&&(ch2Value<30))  
{
motor1.run(FORWARD);
motor2.run(BACKWARD);  
}
else if ((ch1Value>50)&&(ch2Value<30))  {
motor1.run(BACKWARD);
motor2.run(FORWARD);  
}
else  {
motor1.run(RELEASE);
motor2.run(RELEASE);  
}
delay(200);
}
int readChannel(byte channelInput,int minLimit,int maxLimit,int defaultValue) {
int ch=pulseIn(channelInput,HIGH,30000);
if (ch<100) return defaultValue;
return map(ch,1000,2000,minLimit,maxLimit);  
}

bool readSwitch(byte channelInput,bool defaultValue) {
int intDefaultValue=(defaultValue)?100:0;
int ch=readChannel(channelInput,0,100,intDefaultValue);
return(ch>50);  
}
